// CPPWrapper.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "CPPWrapper.h"


#ifdef _MANAGED
#pragma managed(push, off)
#endif

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

#ifdef _MANAGED
#pragma managed(pop)
#endif

#include <cuda.h>
#include <nvpp.h>
#include <stdio.h>

// This is an example of an exported function.
extern "C" CPPWRAPPER_API Nvpp8u* Malloc_C1(int width, int height, int* pitch)
{
	return nvppiMalloc_8u_C1(width, height, pitch);
}

// This is an example of an exported function.
extern "C" CPPWRAPPER_API void Free(void* buffer)
{
	nvppiFree(buffer);
}

extern "C" CPPWRAPPER_API Nvpp8u* Malloc_C4(int width, int height, int* pitch)
{
	return nvppiMalloc_8u_C4(width, height, pitch);
}

extern "C" CPPWRAPPER_API NvppStatus Set_C4(Nvpp32s value, Nvpp32s *buffer, int pitch, NvppiSize size)
{
	return nvppiSet_32s_C1R(value, buffer, pitch, size);
}

extern "C" CPPWRAPPER_API NvppStatus Set_C1(Nvpp8u value, Nvpp8u *buffer, int pitch, NvppiSize size)
{
	return nvppiSet_8u_C1R(value, buffer, pitch, size);
}

extern "C" CPPWRAPPER_API NvppStatus Resize(const Nvpp8u *srcBuf, NvppiSize srcSize, int srcPitch, NvppiRect srcROI, Nvpp8u *dstBuf, int dstPitch, NvppiSize dstROISize, double xFactor, double yFactor, int interp)
{
	return nvppiResize_8u_C4R(srcBuf, srcSize, srcPitch, srcROI, dstBuf, dstPitch, dstROISize, xFactor, yFactor, interp);
}

extern "C" CPPWRAPPER_API NvppStatus Rotate(const Nvpp8u *srcBuf, NvppiSize srcSize, int srcPitch, NvppiRect srcROI, Nvpp8u *dstBuf, int dstPitch, NvppiRect dstROI, double angle, double xShift, double yShift, int interp)
{
	return nvppiRotate_8u_C4R(srcBuf, srcSize, srcPitch, srcROI, dstBuf, dstPitch, dstROI, angle, xShift, yShift, interp);
}

extern "C" CPPWRAPPER_API NvppStatus Erode(const Nvpp8u *srcBuf, int srcPitch, Nvpp8u *dstBuf, int dstPitch, NvppiSize ROI, const Nvpp8u *mask, NvppiSize maskSize, NvppiPoint anchor)
{
	return nvppiErode_8u_C4R(srcBuf, srcPitch, dstBuf, dstPitch, ROI, mask, maskSize, anchor);
}

extern "C" CPPWRAPPER_API NvppStatus Transpose(const Nvpp8u *srcBuf, int srcPitch, Nvpp8u *dstBuf, int dstPitch, NvppiSize ROI)
{
	return nvppiTranspose_8u_C1R(srcBuf, srcPitch, dstBuf, dstPitch, ROI);
}

extern "C" CPPWRAPPER_API NvppStatus Histogram(const Nvpp8u *srcBuf, int srcPitch, NvppiSize ROI, int *histogram, int *levels, int nLevels, int lowerLevel, int upperLevel)
{
	return nvppiHistogramEven_8u_C1R(srcBuf, srcPitch, ROI, histogram, levels, nLevels, lowerLevel, upperLevel);
}
