using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using GASS.CUDA;
using GASS.CUDA.Types;
using NVPP;
using System.Drawing.Imaging;

namespace NVPPHistogram
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnLoad_Click(object sender, EventArgs e)
        {
            //original = (Bitmap)Bitmap.FromFile(@"res\fuchsia.jpg_bw.bmp");
            original = (Bitmap)Bitmap.FromFile(@"res\flower-burst.jpg_8u.bmp");
            pcbOrig.Image = original;
            dst = new Bitmap(original.Width, original.Height, PixelFormat.Format32bppArgb);
        }

        private void btnHistogram_Click(object sender, EventArgs e)
        {
            int srcPitch = 0;
            int dstPitch = 0;
            CUResult cuda_res = CUResult.Success;

            CUdeviceptr orig = NVPPWrapper.Malloc_C1(original.Width, original.Height, ref srcPitch);
            //CUdeviceptr dstBuf = NVPPWrapper.Malloc_C1(dst.Width, dst.Height, ref dstPitch);

            if (orig.Pointer == 0)
            {
                MessageBox.Show("Error allocating memory");
                return;
            }

            NvppStatus res = NVPPWrapper.Set_C1(0, orig, srcPitch, new NvppiSize(original.Width, original.Height));
            //MessageBox.Show(res.ToString());
            //res = NVPPWrapper.Set_C4(Color.Blue.ToArgb(), dstBuf, dstPitch, new NvppiSize(dst.Width, dst.Height));
            //cuda_res = CUDADriver.cuMemsetD8(mask, byte.MaxValue, 3 * 3);

            BitmapData origData = original.LockBits(Rectangle.FromLTRB(0, 0, original.Width, original.Height), ImageLockMode.ReadWrite, PixelFormat.Format8bppIndexed);
            CUDAMemCpy2D copy = new CUDAMemCpy2D();
            copy.srcMemoryType = CUMemoryType.Host;
            copy.srcHost = origData.Scan0;
            copy.srcPitch = (uint)origData.Stride;
            copy.dstMemoryType = CUMemoryType.Device;
            copy.dstDevice = orig;
            copy.dstPitch = (uint)srcPitch;
            copy.WidthInBytes = (uint)(original.Width);
            copy.Height = (uint)original.Height;
            cuda_res = CUDADriver.cuMemcpy2D(ref copy);
            original.UnlockBits(origData);

            int[] histogram = new int[6];
            int[] levels = new int[6];

            CUdeviceptr histo = new CUdeviceptr();
            CUDADriver.cuMemAlloc(ref histo, 6 * 4);

            CUdeviceptr lev = new CUdeviceptr();
            CUDADriver.cuMemAlloc(ref lev, 6 * 4);

            res = NVPPWrapper.Histogram(
                orig,
                srcPitch,
                new NvppiSize(original.Width, original.Height),
                histo,
                levels,
                6,
                28,
                127);

            CUDADriver.cuMemcpyDtoH(histogram, histo, 20);

            //BitmapData dstData = dst.LockBits(Rectangle.FromLTRB(0, 0, dst.Width, dst.Height), ImageLockMode.WriteOnly, PixelFormat.Format32bppArgb);
            //copy = new CUDAMemCpy2D();
            //copy.srcMemoryType = CUMemoryType.Device;
            //copy.srcDevice = dstBuf;
            //copy.srcPitch = (uint)dstPitch;
            //copy.dstMemoryType = CUMemoryType.Host;
            //copy.dstHost = dstData.Scan0;
            //copy.dstPitch = (uint)dstData.Stride;
            //copy.WidthInBytes = (uint)(dst.Width * 4);
            //copy.Height = (uint)dst.Height;
            //cuda_res = CUDADriver.cuMemcpy2D(ref copy);
            //dst.UnlockBits(dstData);

            //// Show result.
            //disp.ClientSize = new Size(dst.Width, dst.Height);
            ////disp.Size.Width = 1024;
            ////disp.Size.Height = 768;
            //disp.StartPosition = FormStartPosition.Manual;
            //disp.Top = 0;
            //disp.Left = 0;
            //PictureBox pcb = new PictureBox();
            //pcb.Size = disp.ClientSize;
            //pcb.Image = dst;
            //disp.Controls.Add(pcb);

            //disp.Show();

            for (int i = 0; i < histogram.Length; i++)
            {
                lstHistograms.Items.Add(string.Format("{0} -> {1}", i, histogram[i]));
            }
        }

        Bitmap original;
        Bitmap dst;
        Form disp = new Form();
    }
}